using System;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using System.Data;

using Cosmos.Win;
using Cosmos.BaseFrame;
using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 통신사(SKT,KT,LGT) 할인
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Win
{
    public partial class frmPntMobileCom : frm_PayMainBack
    {

        #region 변수 선언

        private SManager sManager = new SManager();                                 // 이 객체를 통해 업무 Service 호출
        private StateServer StateObject = (StateServer)StateServer.GetInstance();   // StateObject : StateServer Object (객체)
        private PosStatus m_cPosStatus = new PosStatus();                           // 기본정보 참조
        private TranStatus m_cTrnStatus = new TranStatus();                         // 거래정보 참조        
        private DeviceStatus m_cDevStatus = new DeviceStatus();                     // 디바이스 관리
        private PosOLEDevice.DelegateOlePos delegatePos;
        private PosOLEDevice.DelegateIcReader delegateReader;                       // IC리더 콜백
        //#20170918 IC 콜백 함수 변경 start
        //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
        /*
        private PosOLEDevice.CallbackIc delegateReaderCardInfo;                     // IC리더 콜백(CardInfo)
        private bool m_bCardInPut;                                                  //카드 입력 중복 방지
        private string m_sIcChip;                                                   //IC CHIP DATA(EMV)
        private string m_InputType = ""; //PosConst.POS_VAN_MASTER.VAN_KEYIN;       //입력구분
        private string m_sCardNo;                                                   //입력 카드 번호
        private string m_sFallDiv;                                                  //FallBack구분
        private string m_sServiceCode;                                              //서비스코드
        */
        //#20170918 IC 콜백 함수 변경 end

        private IICReaderUs m_cDeviceICReader = null;
        private ISignPadUs m_cDeviceSignPad = null;
        private IDataProcessUs m_cDataService = null;                               // 거래데이터 합계금액 계산 및 관리
        private IDataCommonUs m_cDataCommon = null;                                 // POS 공통함수 인터페이스
        private IPaymentUs m_cMobilePoint = null;
        //#20180413 웰컴카드 신규기능 추가 start,phj
        private IPaymentExpUs m_cHappyPoint = null;
        private IWelcomeCard m_cWelcomeCard = null;
        private IPaymentUs m_cWelcomeDC = null;
        //#20180413 웰컴카드 신규기능 추가 end,phj

        private bool bNotDoubleClik = false;                                        // 더블 클릭 방지용

        private string m_sPosMenuKey; // 제휴 할인 구분 (SKT, KT, LGT, SPC 임직원 할인)
        /// <summary>
        /// 제휴 할인 구분 (SKT, KT, LGT, SPC 임직원 할인)
        /// </summary>
        public string SetPosMenuKey { set { this.m_sPosMenuKey = value; } }

        /// <summary>
        /// 입력구분
        /// </summary>
        private string m_sInPutType = "";
        /// <summary>
        /// 입력데이터
        /// </summary>
        private string m_sInPutData = "";
        /// <summary>
        /// 마스킹데이터
        /// </summary>
        private string m_sInMaskData = "";
        /// <summary>
        /// 카드데이터(암호화)
        /// </summary>
        private string m_sInEncData = "";
        /// <summary>
        /// 대상 금액
        /// </summary>
        private double m_nDestAmt = 0;
        /// <summary>
        /// T페이 입력구분 (PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE)
        /// </summary>
        private string m_sInEntryMode = "";

        //#20170906 T페이 고도화 작업 phj, start
        private string m_sInCardData = "";
        //#20170906 T페이 고도화 작업 phj, end 

        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
        private string m_sWelcomGiftCode = "";
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END


        //#20180413 웰컴카드 신규기능 추가 start,phj
        /// <summary>
        /// HPC - 회원번호
        /// </summary>
        private string m_sInHP_CustNumer = "";
        /// <summary>
        /// HPC - 웰컴카드번호
        /// </summary>
        private string m_sInHP_WelcomeCard = "";
        /// <summary>
        /// 웰컴카드 카드타입(C:실물카드, A:해피앱)
        /// </summary>
        private string m_sInWelcomeCard_Type = "";
        /// <summary>
        /// 등록건에서읽어온HP데이터등록시킬건지, 조회건에서읽어온HP데이터등록시킬건지
        /// </summary>
        private string m_sReadingHPData = "";
        //#20180413 웰컴카드 신규기능 추가 end,phj 
        
        #endregion 변수 선언

        #region 생성자 & 소멸자 & 폼초기화
        public frmPntMobileCom()
        {
            InitializeComponent();

            base.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint | ControlStyles.ResizeRedraw, true);
            //this.UpdateStyles();

            m_cPosStatus = (PosStatus)StateObject.POS;      // POS 기본정보
            m_cTrnStatus = (TranStatus)StateObject.TRAN;    // POS 거래정보 
            m_cDevStatus = (DeviceStatus)StateObject.DEVICE;

            m_cDeviceICReader = (IICReaderUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_ICREADER);
            m_cDeviceSignPad = (ISignPadUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_SIGNPAD);
            m_cDataService = (IDataProcessUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_SERVICE);
            m_cDataCommon = (IDataCommonUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_COMMON);
            m_cMobilePoint = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTMOBILECOM);

            //#20180413 웰컴카드 신규기능 추가 start,phj
            m_cWelcomeCard = (IWelcomeCard)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.WELCOMECARD_ISSUE);
            m_cHappyPoint = (IPaymentExpUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTHAPPYPOINT);
            m_cWelcomeDC = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.WELCOMECARD_ISSUE);
            //#20180413 웰컴카드 신규기능 추가 end,phj

            delegatePos = new PosOLEDevice.DelegateOlePos(OnDeviceEvent);
            delegateReader = new PosOLEDevice.DelegateIcReader(OnIcReaderCallBack);     // IC리더 콜백
            //#20170918 IC 콜백 함수 변경 start
            //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
            //delegateReaderCardInfo = new PosOLEDevice.CallbackIc(OnIcReaderCallBackCardInfo);     // IC리더 콜백(CardInfo)
            //#20170918 IC 콜백 함수 변경 end
        }

        private void frmMobileComPoint_Load(object sender, EventArgs e)
        {
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "");

            InitControl();

            tmrIcCard.Tag = "";
            tmrIcCard.Enabled = true;   // IC리더 콜백 설정
        }

        private void frmMobileComPoint_Activated(object sender, EventArgs e)
        {
            PosOLEDevice.SetEventHandle(delegatePos);
        }

        private void frmMobileComPoint_Deactivate(object sender, EventArgs e)
        {
            PosOLEDevice.SetEventHandle(null);
        }

        private void frmMobileComPoint_FormClosing(object sender, FormClosingEventArgs e)
        {
            tmrIcCard.Tag = "CLOSE";
            // 마우스(이중클릭방지)
            Point nPoint = System.Windows.Forms.Cursor.Position;
            Cursor.Clip = new System.Drawing.Rectangle(1024, 0, 1, 1);

            UnRegIcCallback();          // IC리더 콜백 해지
            InDataToZeroFill();
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", lblTitle.Text);

            // 마우스(이중클릭방지)
            Cursor.Clip = Screen.PrimaryScreen.Bounds;
            Cursor.Position = nPoint;
        }

        /// <summary>
        /// 폼 컨트롤 초기화
        /// </summary>
        private void InitControl()
        {
            try
            {
                this.Location = new Point(0, 50);
                this.Size = new Size(1024, 525);

                // 이미지 로딩 처리
                //picBack.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.POP_SIZE_S);
                FormManager.SetFormAllControlFont(this, m_cPosStatus.Base.FONT);
                FormManager.SetTextBoxGlobalInfo(this, m_cPosStatus.Global.m_stCultureMaster.nGroupingDigits, m_cPosStatus.Global.m_stCultureMaster.strGroupingSymbol
                    , m_cPosStatus.Global.m_stCultureMaster.nDecimalDigits, m_cPosStatus.Global.m_stCultureMaster.strDecimalSymbol);

                btnExit.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.BTN_CLOSE);
                if (btnExit.Image != null) btnExit.Text = "";

                btnEnter.BackColor = CmUtil.GetColorToString(m_cPosStatus.ScnMst.ThemeColor);

                if (m_sPosMenuKey == PosKey.MENU_KEY.SKT) 
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0072);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.KT) 
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0073);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.LGT) 
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0074);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.KT_VIP) 
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0544);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.KT_DOUBLE)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1024);
                //#20180413 웰컴카드 신규기능 추가 start,phj
                else if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138);
                //#20180413 웰컴카드 신규기능 추가 end,phj  
                
                lblCardNo.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0051);
                lblPayAmt.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0098);
                lblDcAmt.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0036);
                
                btnEnter.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0057);
                btnIcCard.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0132);
                btnCatApp.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0854);

                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                btnWelcomGift.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1097);
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                //#20180413 웰컴카드 신규기능 추가 start,phj
                btnWccIssue.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1131);
                //#20180413 웰컴카드 신규기능 추가 end,phj  

                //#14618 KT 더블할인 개발요청 start,phj
                btnDoubleDC.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1118);
                //#14618 KT 더블할인 개발요청 end,phj


                // 기능 버튼 설정 체크
                FormManager.SetbtnMenu(txtCardNo, m_cDevStatus.ICReader.UseYn, btnIcCard, null, null, null);

                if (m_sPosMenuKey == PosKey.MENU_KEY.KT_VIP)
                {
                    // 통신사 VIP 증정 대상 금액 획득
                    m_nDestAmt = m_cDataCommon.SrarchTermCoopCmpDcItem(ItemConst.TR_ITEM_ID.MOBILE_COM_POINT, ItemConst.TR_ITEM_ID.MOBILE_COM.MOBILE_KT_VIP, "");
                }
                else if (m_sPosMenuKey == PosKey.MENU_KEY.KT_DOUBLE)
                {
                    // KT 멤버십 더블 대상금액 
                    m_nDestAmt = m_cDataCommon.SrarchTermCoopCmpDcItem(ItemConst.TR_ITEM_ID.MOBILE_COM_POINT, ItemConst.TR_ITEM_ID.MOBILE_COM.MOBILE_KT_DOUBLE, "");
                }
                else
                {
                    // 통신사 할인 대상 금액 획득
                    m_nDestAmt = m_cDataService.GetPluTagetAmount(m_sPosMenuKey);
                }
                txtPayAmt.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);  // 할인 대상 금액


                //#20180413 웰컴카드 신규기능 추가 start,phj

                btnWccIssue.Visible = false; 
                if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                {
                    btnWccIssue.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1131);
                    if (PosMstManager.GetPosOption(POS_OPTION.OPT516) == "1")
                    {
                        btnWccIssue.Visible = true;
                    }
                }

                m_sReadingHPData = "";
                //#20180413 웰컴카드 신규기능 추가 end,phj

                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                btnWelcomGift.Visible = false;
                btnWelcomGift.Visible = m_cDataCommon.WelcomGiftBtnYN(ItemConst.DC_APPLY_TRGT.DC_WC_GIFT, m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                //#14618 KT 더블할인 개발요청 start,phj
                btnDoubleDC.Visible = false;
                btnDoubleDC.Visible = m_cDataCommon.WelcomGiftBtnYN(ItemConst.DC_APPLY_TRGT.DC_KT_DOUBLE, m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                //#14618 KT 더블할인 개발요청 end,phj

                InitPayMainBack(m_cPosStatus, m_cDataCommon, m_sPosMenuKey, PosConst.MOT_MSG_TYPE.PAY_STEP_2, "");

                ClearCardInfo();                // 카드 입력 정보 클리어
                bNotDoubleClik = false;

                if (m_cDevStatus.CatTerminal.UseYn == false)
                    btnCatApp.Visible = false;
                else
                    btnCatApp.Visible = true;

                // 무결성 실패후 진행시 오류 메시지 표시
                if (m_cDevStatus.ICReader.UseYn == true)     // 여신전문금융업법 적용여부 체크
                {
                    //#20171208, RF버튼 선택 시에만 서명패드 무결성 체크하도록 수정 Start
                    /*if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true && m_cDevStatus.ICReader.Integrity_SignPad_Status != true && m_cDevStatus.SignPad.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0388);
                    else
                    {
                        if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0384);
                        //if (m_cDevStatus.ICReader.Integrity_SignPad_Status != true && m_cPosStatus.Base.OlePosSignPadUseFlag == "1") WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0385);
                    }*/

                    if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0384);
                    //#20171208, RF버튼 선택 시에만 서명패드 무결성 체크하도록 수정 End
                }

                txtCardNo.Text = "";     
                txtCardNo.ReadOnly = false;
                txtCardNo.Select();
            }
            catch (Exception ex)
            {
               WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        /// <summary>
        /// 카드 입력 정보 클리어
        /// </summary>
        private void ClearCardInfo()
        {
            try
            {
                m_sInPutType = "";      // 입력구분
                m_sInPutData = "";      // 입력데이터
                m_sInMaskData = "";     // 마스킹
                m_sInEncData = "";      // 카드데이터
                m_sInEntryMode = ""; 

                //#20170906 T페이 고도화 작업 phj, start
                m_sInCardData = "";
                //#20170906 T페이 고도화 작업 phj, end 

                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                m_sWelcomGiftCode = "";
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                //#20180413 웰컴카드 신규기능 추가 start,phj 
                m_sInHP_CustNumer = ""; // HPC - 회원번호
                m_sInHP_WelcomeCard = ""; // HPC - 웰컴카드번호
                m_sInWelcomeCard_Type = ""; // 웰컴카드 타입 C:실물카드, A:해피App 
                m_sReadingHPData = "";
                //#20180413 웰컴카드 신규기능 추가 end,phj

                txtDcAmt.Text = "";     
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion

        #region 버튼 입력 처리
        /// <summary>
        /// 버튼 입력 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnProc_Click(object sender, EventArgs e)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                if (((Cosmos.UI.CsmButton)sender) == btnIcCard)               // 카드 등록
                {
                    if (GetIcCardData(e != null ? true : false) == true)
                    {
                        bNotDoubleClik = false;
                        txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                    }
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnEnter)         // 할인승인
                {
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    /*
                    CompleteTxtInPut(0);
                    */
                    //변경
                    CompleteTxtInPut(0, btnEnter);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                }
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                else if (((Cosmos.UI.CsmButton)sender) == btnWelcomGift)
                {
                    

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    /*
                    CompleteTxtInPut(3);
                    */
                    //변경
                    CompleteTxtInPut(3, btnWelcomGift);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                }
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                //#14618 KT 더블할인 개발요청 start,phj
                else if (((Cosmos.UI.CsmButton)sender) == btnDoubleDC)
                {
                    

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    /*
                    CompleteTxtInPut(3);
                    */
                    //변경
                    CompleteTxtInPut(3, btnDoubleDC);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                }
                //#14618 KT 더블할인 개발요청 end,phj

                else if (((Cosmos.UI.CsmButton)sender) == btnExit)
                {
                    bNotDoubleClik = false;

                    this.DialogResult = DialogResult.Cancel;
                    this.Close();
                    return;
                }
                //#20180413 웰컴카드 신규기능 추가 start,phj
                else if (((Cosmos.UI.CsmButton)sender) == btnWccIssue)        // 웰컴카드 발급
                {
                    WelcomeCard_Issue();
                }
                //#20180413 웰컴카드 신규기능 추가 end,phj
                else if (((Cosmos.UI.CsmButton)sender) == btnCatApp)    //CAT단말기
                {
                    

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    /*
                    CompleteTxtInPut(1);
                    */
                    //변경
                    CompleteTxtInPut(1, btnCatApp);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
        

                }
                padInPut.SetActiveFocus();
            }
            catch (Exception ex)
            {
               WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
               bNotDoubleClik = false;
            }
            bNotDoubleClik = false;
        }
        #endregion

        #region 텍스트박스 키 입력 이벤트 처리
        /// <summary>
        /// 텍스트박스 키 입력 이벤트 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="sFuncValue"></param>
        private void txtEditBox_EditBoxKeyDownEvent(object sender, string sFuncValue)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                try
                {
                   if (sFuncValue == PosKey.MENU_KEY.ENTER)
                    {
                        if (((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                        {
                            if (txtCardNo.Text == "")
                            {
                                if (GetIcCardData(true) == false) return;
                            }

                            if (CheckTxtInPut(sender) == false) return;

                            // T페이 결제전환 처리
                            if (ChangeTPayPayment() == true) return;

                            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START

                            //#14618 KT 더블할인 개발요청 start,phj
                            if (btnWelcomGift.Visible == true || btnDoubleDC.Visible == true)
                            //#14618 KT 더블할인 개발요청 end,phj
                            {

                                //웰컴 기프트 대상일 때는 ktf 자동승인 안되도록 막음 
                                bNotDoubleClik = false;
                                return;
                            }
                            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                            


                            //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                            //기존
                            /*
                            CompleteTxtInPut(0);     // 승인
                            */
                            //변경
                            CompleteTxtInPut(0, sender);
                            //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                        }
                    }
                    else if (sFuncValue == PosKey.MENU_KEY.CLEAR)
                    {
                        if (((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                        {
                            ClearCardInfo();        // 카드 입력 정보 클리어
                            tmrIcCard.Enabled = true;
                        }

                        if (((Cosmos.UI.CsmPosEditBox)sender).ReadOnly == false) ((Cosmos.UI.CsmPosEditBox)sender).Text = "";
                    }
                }
                catch (Exception ex)
                {
                    WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                }
                finally
                {
                    bNotDoubleClik = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            bNotDoubleClik = false;
        }

        /// <summary>
        /// 텍스트박스 활성화 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtEditBox_EnterEvent(object sender, EventArgs e)
        {
            try
            {
                padInPut.SetActiveControl = (Control)sender;
            }
            catch (Exception ex)
            {
               WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion        

        #region 텍스트박스 입력 유효성 체크
        /// <summary>
        /// 텍스트박스 입력 유효성 체크
        /// </summary>
        /// <param name="sender"></param>
        /// <returns></returns>
        private bool CheckTxtInPut(object sender)
        {
            try
            {
                // 특정 문자값 제거
                try
                {
                    if (m_cDevStatus.Msr.STX != "" && txtCardNo.Value.StartsWith(m_cDevStatus.Msr.STX)) txtCardNo.Value = txtCardNo.Value.Substring(1);

                    int iLastEtx = txtCardNo.Value.LastIndexOf(m_cDevStatus.Msr.ETX);
                    if (m_cDevStatus.Msr.ETX != "" && iLastEtx > 0) txtCardNo.Value = CmUtil.MidH(txtCardNo.Value, 0, iLastEtx);
                }
                catch { }

                // 카드번호 길이 체크
                if (sender == null || ((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                {
                    if (txtCardNo.Value.Length < 10)
                    {
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0037);
                        txtCardNo.Focus();
                        return false;
                    }

                    if (m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                    {
                        if (txtCardNo.Value.StartsWith("4282") == true)     // 해피기프트 카드 안내
                        {
                            WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0649);
                            txtCardNo.Focus();
                            return false;
                        }
                    }

                    // 입력된 카드번호 변경 체크
                    if (txtCardNo.Value != m_sInPutData)
                    {
                        ClearCardInfo();        // 카드 입력 정보 클리어   
                    }

                    if (m_sInEncData == "")
                    {
                        if (m_sInPutData == "")
                        {
                            m_sInPutData = txtCardNo.Value;
                            if (m_sInPutData.Length > 16 && CmUtil.IsNumber(m_sInPutData.Substring(16, 1)) == false)
                            {
                                m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_MOBILE_SWIP;
                                m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.KEYIN;
                                //txtCardNo.Value = m_sInPutData.Substring(0, 16);
                            }
                            else
                            {
                                m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_KEYIN;
                                m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.KEYIN;
                            }
                            if (m_sInPutData.Contains("=") == true) m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        }
                        if (EncryptedCardNo(m_sInPutData, ref m_sInMaskData, ref m_sInEncData) == false) return false;

                        //#20180413 웰컴카드 신규기능 추가 start,phj
                        #region 웰컴카드 카드리딩
                        if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                        {
                            // 카드타입읽어오기.
                            m_sInWelcomeCard_Type = m_cWelcomeCard.WelcomeCard_PrefixCheck(txtCardNo.Value);
                            //SelectMobileUnityKind();

                            // 기능키셋팅.
                            if (m_sInWelcomeCard_Type == "C" || m_sInWelcomeCard_Type == "A")
                            {
                                m_sPosMenuKey = PosKey.MENU_KEY.WELCOMECARD_DC;

                                if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC && m_sInWelcomeCard_Type == "C")
                                {
                                    m_sInHP_WelcomeCard = m_sInPutData;
                                }
                                else if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC && (m_sInWelcomeCard_Type == "A" || m_sInWelcomeCard_Type == ""))
                                {
                                    // 유효한 해피포인트인지 체크. 
                                    if (HP_Availability_Check() == false)
                                    {
                                        txtCardNo.SelectText();
                                        txtCardNo.Focus();
                                        ClearCardInfo();
                                        txtCardNo.Text = "";
                                        txtCardNo.Value = "";
                                        return false;
                                    }

                                    //카드번호 변경해서 재리딩.
                                    txtCardNo.Text = m_sInHP_WelcomeCard;
                                    txtCardNo.Value = m_sInHP_WelcomeCard;

                                    m_sInWelcomeCard_Type = "A";

                                    //SelectMobileUnityKind();

                                    m_sInPutData = txtCardNo.Value;
                                    m_sInMaskData = m_sInPutData;
                                    if (EncryptedCardNo(m_sInPutData, ref m_sInMaskData, ref m_sInEncData) == false) return false;
                                }
                            }
                            //#20180605 
                            //else
                            //{
                            //    m_sPosMenuKey = "";
                            //}
                        }

                        #endregion  
                        //#20180413 웰컴카드 신규기능 추가 end,phj  
                    }

                    //#20170906 T페이 고도화 작업 phj, start
                    if ((m_sPosMenuKey == PosKey.MENU_KEY.SKT) && 
                        (txtCardNo.Value.StartsWith("294") == true) || (txtCardNo.Value.StartsWith("292") == true) || (txtCardNo.Value.StartsWith("297") == true)) 
                    {
                        m_sInCardData = m_sInPutData;
                    }
                    //#20170906 T페이 고도화 작업 phj, end


                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    /*
                    //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                    btnWelcomGiftYN(m_sPosMenuKey);
                    //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                    //#14618 KT 더블할인 개발요청 start,phj
                    btnKTDoubleDcYN(m_sPosMenuKey);
                    //#14618 KT 더블할인 개발요청 end,phj
                    */
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj

                }
                return true;
            }
            catch (Exception ex)
            {
               WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                return false;
            }
            return true;
        }
        #endregion

        #region 텍스트박스 입력 완료 처리
        /// <summary>
        /// 할인 승인 처리
        /// </summary>
        /// <param name="nFlowMode"></param>
        /// <returns></returns>
        

        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
        //기존
        //private bool CompleteTxtInPut(int nFlowMode)
        //변경
        private bool CompleteTxtInPut(int nFlowMode, object sender)
        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
        {
            string sRet = UserCom.RST_ERR;
            try
            {

                //Cat단말기 승인
                if (nFlowMode == 1)
                {
                    //if (CheckTxtInPut(txtPayAmt) == false) return false;

                    //InParam
                    // 0.전문구분,1.거래유형, 2.할부개월, 3.승인금액 , 4.봉사료, 5.세금, 6.원승인번호, 7.원거래일자, 8.포인트거래구분, 9.상품코드,
                    //10.전표인쇄여부, 11.추가항목, 12.제휴할인코드, 13.제휴할인금액, 14.예비1, 15.예비2

                    //#20170906 T페이 고도화 작업 phj, start
                    //기존
                    //승인처리                                                   0,                      1,       2,            3,             4,   5,  6,  7,  8,      9,     10,  11,      12,       13, 14, 15 
                    //sRet = m_cMobilePoint.SetPayment(new string[] { PosConst.POS_CAT_MASTER.TRAN_TYPE, "", "00", m_nDestAmt.ToString(), "0", "0", "", "", "", "", "", "", m_sPosMenuKey, "", "", "" });
                    //변경                                  
                    sRet = m_cMobilePoint.SetPayment(new string[] { PosConst.POS_CAT_MASTER.TRAN_TYPE, "", "00", m_nDestAmt.ToString(), "0", "0", "", "", "", "", "", "", m_sPosMenuKey, "", m_sInCardData, "" });
                    //#20170906 T페이 고도화 작업 phj, end  
                    
                    if (sRet != UserCom.RST_OK)
                    {
                        InDataToZeroFill();
                        txtCardNo.Focus();
                        return false;
                    }

                }
                else
                {
                    if (CheckTxtInPut(null) == false) return false;


                    //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                    //기존
                    /*
                    //#20170906 T페이 고도화 작업 phj, start
                    //기존
                    //통신사 할인 처리
                    //sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "" });

                    //변경                                  
                    sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "", "", "", "", "", "", "", "", m_sInCardData, "" });
                    //#20170906 T페이 고도화 작업 phj, end  
                    */

                    //변경
                    if (nFlowMode == 3)
                    {
                        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                        if (sender == btnWelcomGift)
                        {
                            bool bRet = false;
                            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START                            
                            bRet = btnWelcomGiftYN(m_sPosMenuKey);
                            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                            if (bRet == false)
                            {
                                WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                                return false;
                            }
                        }
                        else if (sender == btnDoubleDC)
                        {
                            bool bRet = false;
                            //#14618 KT 더블할인 개발요청 start,phj
                            bRet = btnKTDoubleDcYN(m_sPosMenuKey);
                            //#14618 KT 더블할인 개발요청 end,phj
                            if (bRet == false)
                            {
                                WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                                return false;
                            }
                        }
                        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj

                        sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "", "", "", "", "", "", "", "", m_sInCardData, m_sWelcomGiftCode });
                    }

                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    else if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                    {
                        UserLog.WriteLogFile(UserCom.LOG_IOS,
                                             System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                             System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                             System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                             "[CompleteTxtInPut] WCC Start! (m_sPosMenuKey :" + m_sPosMenuKey + ")");
                       
                        if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1")
                        {
                            WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0790);
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }

                        #region 멤버십할인 승인

                        //#20180605 실물카드 구분 비어 있을 경우 C로 픽스 start
                        m_sInWelcomeCard_Type = m_sInWelcomeCard_Type == "" ? "C" : m_sInWelcomeCard_Type;
                        //#20180605 실물카드 구분 비어 있을 경우 C로 픽스 end

                        bool bSuccess = false;
                        string[] saRecvdData = null; 
                        sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                                                                             m_sInPutData, 
                                                                             m_sInPutType, 
                                                                             m_sInHP_CustNumer, 
                                                                             m_sInHP_WelcomeCard, 
                                                                             m_sInWelcomeCard_Type, 
                                                                             "",
                                                                             m_nDestAmt.ToString(),
                                                                             DateTime.Now.ToString("yyyyMMdd"), 
                                                                             DateTime.Now.ToString("HHmmss"), 
                                                                             ""}, ref saRecvdData);

                        UserLog.WriteLogFile(UserCom.LOG_IOS,
                                             System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                             System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                             System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                             "[CompleteTxtInPut] WCC End! (Result :" + sRet.ToString());

                        if (sRet == UserCom.RST_OK)
                        {
                            bSuccess = true;
                            
                            //#20180605 null 체크 start
                            // 웰컴할인 적용했는데
                            // 해피포인트 적용이 되어있으면 
                            //if (saRecvdData != null && m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sHPCustNo].Trim() == "")
                            //{
                            //    UserLog.WriteLogFile(UserCom.LOG_IOS,
                            //                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                            //                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                            //                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                            //                         "[CompleteTxtInPut] WelcomeCard_ClientRegister!  ");
                            //
                            //    WelcomeCard_ClientRegister();
                            //}

                            if (saRecvdData != null)
                            {
                                if (m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sHPCustNo].Trim() == "")
                                {
                                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                                         "[CompleteTxtInPut] WelcomeCard_ClientRegister!  ");

                                    WelcomeCard_ClientRegister();
                                }
                            }
                            //#20180605 null 체크 end
                        }
                        else
                        {
                            bSuccess = false;

                            //#20180605 null 체크 start

                            // 웰컴카드 적용 실패했는데, 그 원인이 미발급 처리된 카드일 때.
                            //if (saRecvdData != null && m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sReqCode].Trim() == "00301")
                            //{
                            //    //if (WinManager.QuestionMessage("발급 처리 되지 않은 카드입니다. 발급 처리 하시겠어요?") == true)
                            //    if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1141), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1131)) == true)
                            //    {
                            //        if (WelcomeCard_Issue(m_sInPutData) == true)
                            //        {
                            //            //if (WinManager.QuestionMessage("발급 처리 되었습니다. 할인 진행하시겠어요?") == true)
                            //            if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1142), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138)) == true)
                            //            {
                            //                // 발급 성공 시 '발급 처리 되었습니다. 할인 진행하시겠어요?' 할인여부 안내 후 할인을 진행 할 수 있도록 한다.
                            //                sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                            //                                                                     m_sInPutData, 
                            //                                                                     m_sInPutType, 
                            //                                                                     m_sInHP_CustNumer, 
                            //                                                                     m_sInHP_WelcomeCard, 
                            //                                                                     m_sInWelcomeCard_Type, 
                            //                                                                     "",
                            //                                                                     m_nDestAmt.ToString(),
                            //                                                                     DateTime.Now.ToString("yyyyMMdd"), 
                            //                                                                     DateTime.Now.ToString("HHmmss"), 
                            //                                                                     ""},
                            //                                                                     ref saRecvdData);
                            //
                            //                if (sRet == UserCom.RST_OK)
                            //                {
                            //                    bSuccess = true;
                            //                }
                            //            }
                            //        }
                            //    }
                            //}

                            if (saRecvdData != null)
                            {
                                if (m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sReqCode].Trim() == "00301")
                                {
                                    if (WelcomeCard_Issue(m_sInPutData) == true)
                                    {
                                        //if (WinManager.QuestionMessage("발급 처리 되었습니다. 할인 진행하시겠어요?") == true)
                                        if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1142), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138)) == true)
                                        {
                                            // 발급 성공 시 '발급 처리 되었습니다. 할인 진행하시겠어요?' 할인여부 안내 후 할인을 진행 할 수 있도록 한다.
                                            sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                                                                                                 m_sInPutData, 
                                                                                                 m_sInPutType, 
                                                                                                 m_sInHP_CustNumer, 
                                                                                                 m_sInHP_WelcomeCard, 
                                                                                                 m_sInWelcomeCard_Type, 
                                                                                                 "",
                                                                                                 m_nDestAmt.ToString(),
                                                                                                 DateTime.Now.ToString("yyyyMMdd"), 
                                                                                                 DateTime.Now.ToString("HHmmss"), 
                                                                                                 ""},
                                                                                                 ref saRecvdData);
                                    
                                            if (sRet == UserCom.RST_OK)
                                            {
                                                bSuccess = true;
                                            }
                                        }
                                        else
                                        {
                                            bSuccess = true;
                                        }
                                    }
                                } 
                            }
                            //#20180605 null 체크 end
                        }

                        if (bSuccess == false)
                        {
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }

                        #endregion 
                    }
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                    else
                    {
                        sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "", "", "", "", "", "", "", "", m_sInCardData, "" });
                    }
                    //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                    if (sRet != UserCom.RST_OK)
                    {
                        InDataToZeroFill();
                        txtCardNo.Focus();
                        return false;
                    }
                }
                 
                this.DialogResult = DialogResult.OK;
                this.Close();

                return true;
            }
            catch (Exception ex)
            {
               WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        
        /// <summary>
        /// 할인 조회 처리
        /// </summary>
        /// <returns></returns>
        private bool SearchTxtInPut()
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (CheckTxtInPut(null) == false) return false;

                // 조회
                string[] saRecvdData = null;
                sRet = m_cMobilePoint.SearchPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString() }, ref saRecvdData);
                if (sRet != UserCom.RST_OK) return false;

                Column.TR_PAYMENT.DATA cPayItem = (Column.TR_PAYMENT.DATA)m_cMobilePoint.GetPayment(new string[]{});
                txtDcAmt.Text = m_cPosStatus.Global.NumericTOCurrency(cPayItem.PAY_AMT);

                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #endregion

        #region DeviceEvent 관련
        /// <summary>
        /// DeviceEvent 관련
        /// </summary>
        /// <param name="sDevice"></param>
        /// <param name="sData1"></param>
        /// <param name="sData2"></param>
        /// <param name="sData3"></param>
        public void OnDeviceEvent(string sDevice, string sData1, string sData2, string sData3)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                switch (sDevice)
                {
                    case PosConst.OPOS_DEVICE.MSR:
                        this.Invoke(new EventHandler(OnMSREvent));
                        break;
                    case PosConst.OPOS_DEVICE.SCANNER:
                        this.Invoke(new EventHandler(OnScannerEvent));
                        break;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
            bNotDoubleClik = false;
        }

        /// <summary>
        /// MSR Event
        /// </summary>
        /// <param name="source"></param>
        /// <param name="e"></param>
        private void OnMSREvent(object source, EventArgs e)
        {
            try
            {
                string sMsrData = m_cDevStatus.Msr.Track2Data;
                if (sMsrData.Length > 0)
                {
                    m_sInEncData = "";
                    m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                    m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.SWIP;
                    m_sInPutData = sMsrData;

                    txtCardNo.Value = m_sInPutData.Length > 16 ? m_sInPutData.Substring(0, 16) : m_sInPutData;

                    txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        /// <summary>
        /// 스캐너 이벤트 처리
        /// </summary>
        /// <param name="source"></param>
        /// <param name="e"></param>
        private void OnScannerEvent(object source, EventArgs e)
        {
            try
            {
                string sScanData = m_cDevStatus.Scanner.DataLabel;
                if (sScanData.Length > 0)
                {
                    m_sInEncData = "";
                    m_sInPutData = sScanData;
                    if (m_sInPutData.Length > 16 && CmUtil.IsNumber(m_sInPutData.Substring(16, 1)) == false)
                    {
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_MOBILE_SWIP;
                        m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.BARCODE;
                        txtCardNo.Value = m_sInPutData.Substring(0, 16);
                    }
                    else
                    {
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_KEYIN;
                        m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.BARCODE;
                        txtCardNo.Value = m_sInPutData;
                    }

                    txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        /// <summary>
        /// 카드 번호 암호화
        /// </summary>
        /// <param name="sInData"></param>
        /// <param name="sInMaskData"></param>
        /// <param name="sInEncData"></param>
        /// <returns></returns>
        private bool EncryptedCardNo(string sInData, ref string sInMaskData, ref string sInEncData)
        {
            string sEncData = sInData;
            bool bRet = false;
            try
            {
                UnRegIcCallback();              // IC리더 콜백 해지

                sEncData = m_cDeviceICReader.GetEncryptedCardNo(sInData).Trim();
                if (CmUtil.MidH(sEncData, 0, 2) == "00")
                {
                    sInEncData = CmUtil.MidH(sEncData, 2, 512).Trim();                          // 암호화 데이터
                    sInMaskData = CmUtil.MidH(sEncData, 514, sEncData.Length - 514).Trim();     // 마스킹 데이터
                    bRet = true;
                }
                else
                {
                    //암호화 처리 실패!
                    UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                        System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "Fail =>" + sInData);
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0280);
                }
                if (txtCardNo.Value == "") tmrIcCard.Enabled = true;    // IC리더 콜백 설정
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return bRet;
        }

        /// <summary>
        /// IC 카드 정보 입력 처리
        /// </summary>
        /// <returns></returns>
        private bool GetIcCardData(bool bCancelCallBack)
        {
            try
            {
                if (bCancelCallBack == true) UnRegIcCallback(); // IC리더 콜백 해지

                txtCardNo.Value = "";
                ClearCardInfo();        // 카드 입력 정보 클리어

                string sRsvStr = "";
                if (m_cDeviceICReader.GetCardInfo_ICReader(PosConst.IC_READER_TRAN_TYPE.POINT, (int)m_nDestAmt, ref sRsvStr) == true)
                {
                    if (CmUtil.MidH(sRsvStr, 0, 2) == "00")
                    {
                        m_sInEncData = CmUtil.MidH(sRsvStr, 6, 512).Trim();
                        m_sInMaskData = CmUtil.MidH(sRsvStr, 1030, 37).Trim();
                        m_sInPutData = m_sInMaskData;
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.SWIP;

                        txtCardNo.Value = m_sInPutData.Length > 16 ? m_sInPutData.Substring(0, 16) : m_sInPutData;

                        //tmrIcCard.Enabled = true;       // IC리더 콜백 설정
                        return true;
                    }
                }
                if (txtCardNo.Value == "") tmrIcCard.Enabled = true;       // IC리더 콜백 설정
                // WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0321);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #endregion

        #region 여전법 대응
        /// <summary>
        /// ZeroFill 초기화
        /// </summary>
        private void InDataToZeroFill()
        {
            try
            {

                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref m_sInPutData);
                CmUtil.ZeroFillClear(ref m_sInEncData);
                CmUtil.ZeroFillClear(ref m_sInMaskData);
                //////////////////////////////////////////////////////////////////////////////////

                txtCardNo.Value = string.Empty;
            }
            catch (Exception) { }

        }
        #endregion 여전법 대응

        private void lblCardNo_MouseDown(object sender, MouseEventArgs e)
        {
            //if (e.Button == System.Windows.Forms.MouseButtons.Right)
            //{
            //    if (m_sPosMenuKey == PosKey.MENU_KEY.SKT) m_cDevStatus.Scanner.DataLabel = "2142059067931027";
            //    else if (m_sPosMenuKey == PosKey.MENU_KEY.KT) m_cDevStatus.Scanner.DataLabel = "2917101119437242";
            //    else if (m_sPosMenuKey == PosKey.MENU_KEY.LGT) m_cDevStatus.Scanner.DataLabel = "2010015660273019";
            //    else if (m_sPosMenuKey == PosKey.MENU_KEY.KT_VIP) m_cDevStatus.Scanner.DataLabel = "2917101008385347";
                
            //    OnScannerEvent(null, null);
            //}
        }

        /// <summary>
        /// T페이 결제 여부 확인
        /// </summary>
        /// <returns></returns>
        private bool ChangeTPayPayment()
        {
            try
            {
                // SKT 제휴할인 일때
                if (m_sPosMenuKey != PosKey.MENU_KEY.SKT) return false;

                // 할인대상금액 확인 
                if (m_nDestAmt <= 0) return false;

                // T페이 기능키 사용여부 확인 
                //DataTable dt = m_cDataCommon.SeletFuncKeyGroup(PosKey.MENU_KEY.PAY_DC_MENU);
                DataTable dt = m_cDataCommon.SeletFuncKeyGroup("");
                if (dt == null || dt.Rows.Count == 0) return false; 
                DataRow[] dr = dt.Select("FUNC_ID = '" + PosKey.MENU_KEY.T_PAY + "'");
                if (dr == null || dr.Length == 0) return false; 

                // T페이 카드 프리픽스 체크 
                IPaymentUs cTPayService = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.TPAY);
                string[] aRet = new string[2];
                string ret = cTPayService.SearchPayment(new string[]{PosConst.TPAY_SEARCH_TYPE.PREFIX, m_sInMaskData}, ref aRet);
                if (ret != UserCom.RST_OK) return false;

                //// 할인/통합결제 선택 
                //frmChoiceBox fChoice = (frmChoiceBox)FormManager.GetForm(FormManager.FORM_CHOICE_BOX);
                //if (fChoice == null)
                //{
                //    fChoice = new frmChoiceBox();
                //    FormManager.AddForm(FormManager.FORM_CHOICE_BOX, fChoice);
                //}
                //fChoice.TitleText = string.Empty;
                //fChoice.MessageText = MessageManager.GetGuideMessage(POS_MESSAGE.GUIDE.MSG_0009);
                //fChoice.ChoiceButtonText01 = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0868);
                //fChoice.ChoiceButtonText02 = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0869);
                //fChoice.SetLocation(216, 173);
                //fChoice.ShowDialog();
                //string choice = fChoice.ChoiceButtonNo;

                string choice = WinBasic.ShowForm(new string[] { FormManager.FORM_CHOICE_BOX
                    , ""
                    , MessageManager.GetGuideMessage(POS_MESSAGE.GUIDE.MSG_0009)
                    , MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0868)
                    , MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0869)
                    ,"216"
                    ,"173"
                    , "0"
                });
                
                if (choice != "2") return false;


                // T페이 통합결제 전환 
                frmTPay fTPay = (frmTPay)FormManager.GetForm(FormManager.FORM_PAY_TPAY);
                if (fTPay == null)
                {
                    fTPay = new frmTPay();
                    FormManager.AddForm(FormManager.FORM_PAY_TPAY, fTPay);
                }
                fTPay.PosMenuKey = PosKey.MENU_KEY.T_PAY;
                fTPay.SetTPayData(m_sInPutType, m_sInEntryMode, m_sInPutData, m_sInMaskData, m_sInEncData, m_nDestAmt, PosConst.TPAY_TRADE_TYPE.COMPLEX);
                if (fTPay.ShowDialog() == DialogResult.OK)
                {
                    this.DialogResult = System.Windows.Forms.DialogResult.OK;
                }
                else
                {
                    this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
                }

                this.Close();
                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                            ex.Message);
                return false; 
            }
        }
        
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
        #region 웰컴 기프트 버튼 선택
        private void btnWelcomGiftClick(object sender, EventArgs e)
        {
            try
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "웰컴 기프트 Button Start!!!");


                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                //기존
                /*
                if (btnWelcomGiftYN(m_sPosMenuKey) == false)
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                    return;
                }
                CompleteTxtInPut(3);
                */
                //변경
                CompleteTxtInPut(3, sender);
                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj

                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "웰컴 기프트 Button End!!! ProductCode : " + m_sWelcomGiftCode);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }

        }
        #endregion
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
        #region 웰컴 기프트 버튼 활성화 유무
        private bool btnWelcomGiftYN(string m_sPosMenuKey)
        {
            bool bRet = true;

            try
            {
                m_sWelcomGiftCode = "";
                btnWelcomGift.Visible = false;


                //#14618 KT 더블할인 개발요청 start,phj
                //기존
                //btnWelcomGift.Visible = m_cDataCommon.WelcomGiftBtnYN(m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                //변경
                btnWelcomGift.Visible = m_cDataCommon.WelcomGiftBtnYN(ItemConst.DC_APPLY_TRGT.DC_WC_GIFT, m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                //#14618 KT 더블할인 개발요청 start,phj


                if (btnWelcomGift.Visible == true && m_sWelcomGiftCode == "")
                {
                    bRet = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return bRet;
        }
        #endregion
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

        #region IC리더 콜백 관련
        /// <summary>
        /// IC리더 콜백 설정
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tmrIcCard_Tick(object sender, EventArgs e)
        {
            try
            {
                if (m_cDevStatus.ICReader.UseYn != true)             // 여전법 인증여부(0:MSR, 1:IC)
                {
                    tmrIcCard.Enabled = false;
                    return;
                }

                if (tmrIcCard.Tag == null || tmrIcCard.Tag.ToString() == "")
                {
                    // IC리더 콜백 설정
                    if (bNotDoubleClik) return;

                    tmrIcCard.Enabled = false;

                    //#20170918 IC 콜백 함수 변경 start
                    //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
                    //기존
                    m_cDeviceICReader.RegIcCallback(delegateReader);
                    //변경
                    //string sApprID = PosMstManager.GetMstVan(ItemConst.TR_ITEM_ID.CREDITCARD_ITEM, ItemConst.TR_ITEM_ID.CREDITCARD.CREDIT_CARD, PosMst.MST_VAN.DATA.APPR_ID);
                    //m_cDeviceICReader.RegIcCallbackCardInfo(sApprID, m_cDataService.IntParse(txtDcAmt.Text), delegateReaderCardInfo);
                    //#20170918 IC 콜백 함수 변경 end
                }
                else if (tmrIcCard.Tag.ToString() == "MSR")
                {
                    // MSR 카드 읽기
                    tmrIcCard.Enabled = false;
                    tmrIcCard.Tag = "";
                    tmrIcCard.Interval = 500;

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    /*
                    CompleteTxtInPut(0);       // 승인처리
                    */
                    //변경
                    CompleteTxtInPut(0, sender);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj

                    tmrIcCard.Enabled = true;
                }
                else if (tmrIcCard.Tag.ToString() == "IC")
                {
                    // IC리더 카드 읽기
                    tmrIcCard.Enabled = false;
                    tmrIcCard.Tag = "";
                    tmrIcCard.Interval = 500;

                    bNotDoubleClik = false;
                    btnProc_Click(btnIcCard, null);
                }
                else
                    tmrIcCard.Enabled = false;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        delegate void DelegateIcReaderCallBack(int rc, StringBuilder str);
        /// <summary>
        /// IC리더 콜백 함수
        /// </summary>
        /// <param name="num"></param>
        /// <param name="str"></param>
        public void OnIcReaderCallBack(int num, StringBuilder str)
        {
            try
            {
                if (txtCardNo.InvokeRequired)
                {
                    DelegateIcReaderCallBack d = new DelegateIcReaderCallBack(OnIcReaderCallBack);
                    this.Invoke(d, new object[] { num, str });
                }
                else
                {
                    if (bNotDoubleClik) return;
                    bNotDoubleClik = true;

                    if (num == 1)
                    {
                        // IC 카드
                        tmrIcCard.Tag = "IC";
                        tmrIcCard.Interval = 100;
                    }
                    else
                    {
                        // MSR 카드
                        if (str.ToString().StartsWith("EN") == true)
                        {
                            m_sInEncData = CmUtil.MidH(str.ToString(), 0, 512).Trim();
                            m_sInMaskData = CmUtil.MidH(str.ToString(), 512, 40).Trim();
                            m_sInPutData = m_sInMaskData;
                            m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;

                            txtCardNo.Value = m_sInPutData;
                            tmrIcCard.Tag = "MSR";

                            tmrIcCard.Interval = 100;
                        }
                        else
                        {
                            tmrIcCard.Interval = 500;
                        }
                    }
                    tmrIcCard.Enabled = true;

                    bNotDoubleClik = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                        System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
        }

        /// <summary>
        /// IC리더 콜백 해지
        /// </summary>
        private void UnRegIcCallback()
        {
            try
            {
                if (m_cDevStatus.ICReader.UseYn == true)     // 여신전문금융업법 적용여부 체크
                {
                    tmrIcCard.Enabled = false;

                    //#20170918 IC 콜백 함수 변경 start
                    //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
                    //기존
                    m_cDeviceICReader.UnRegIcCallback();
                    //변경
                    //m_cDeviceICReader.UnRegIcCallbackCardInfo();
                    //#20170918 IC 콜백 함수 변경 end
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        //#14618 KT 더블할인 개발요청 start,phj
        #region KT 더블할인 버튼 유무 
        private bool btnKTDoubleDcYN(string m_sPosMenuKey)
        {
            bool bRet = true;
            try
            {
                m_sWelcomGiftCode = "";
                btnDoubleDC.Visible = false;
                btnDoubleDC.Visible = m_cDataCommon.WelcomGiftBtnYN(ItemConst.DC_APPLY_TRGT.DC_KT_DOUBLE, m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                if (btnDoubleDC.Visible == true && m_sWelcomGiftCode == "")
                {
                    bRet = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return bRet;
        }
        #endregion
        //#14618 KT 더블할인 개발요청 end,phj

        //#14618 KT 더블할인 개발요청 start,phj
        #region KT 더블할인 버튼 클릭
        private void btnDoubleDC_Click(object sender, EventArgs e)
        {
            try
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "KT Double DC Button Start!!!");


                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                //기존
                /*
                if (btnKTDoubleDcYN(m_sPosMenuKey) == false)
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                    return;
                }
                CompleteTxtInPut(3);
                */
                //변경
                CompleteTxtInPut(3, sender);
                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj

                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "KT Double DC Button End!!! ProductCode : " + m_sWelcomGiftCode);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion
        //#14618 KT 더블할인 개발요청 end,phj

        //#20170918 IC 콜백 함수 변경 start
        //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
        /*
        delegate void DelegateWriteLog(int returnValue, StringBuilder returnData);
        /// <summary>
        /// IC리더 콜백 함수(CardInfo)
        /// </summary>
        /// <param name="returnValue"></param>
        /// <param name="returnData"></param>
        public void OnIcReaderCallBackCardInfo(int returnValue, StringBuilder returnData)
        {
            if (txtCardNo.InvokeRequired)
            {
                DelegateWriteLog d = new DelegateWriteLog(OnIcReaderCallBackCardInfo);
                this.Invoke(d, new object[] { returnValue, returnData });
            }
            else
            {
                if (m_bCardInPut) return;
                m_bCardInPut = true;

                if (returnValue > 0)
                {
                    string sRsvStr = returnData.ToString();
                    if (CmUtil.MidH(sRsvStr, 0, 2) == "00")
                    {
                        m_sCardNo = CmUtil.MidH(sRsvStr, 6, 512).Trim();
                        txtCardNo.Value = CmUtil.MidH(sRsvStr, 1030, 37).Trim();
                        m_sIcChip = CmUtil.MidH(sRsvStr, 518, 512).Trim();
                        if (CmUtil.MidH(sRsvStr, 4, 2).Trim() == "02")
                        {
                            m_InputType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        }
                        else
                        {
                            m_InputType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_IC;
                        }
                        m_sServiceCode = CmUtil.MidH(sRsvStr, 1067, 5).Trim();
                        m_sFallDiv = CmUtil.MidH(sRsvStr, 3, 1); // == "3" ? "0" : "1";

                        // IC 카드(CardInfo)
                        tmrIcCard.Tag = "ICREADER";
                        tmrIcCard.Interval = 100;
                        tmrIcCard.Enabled = true;

                        m_bCardInPut = false;
                    }
                }
            }

        }
        */
        //#20170918 IC 콜백 함수 변경 end

        #endregion


        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 웰컴카드 발급 버튼
        /// <summary>
        /// 웰컴카드 발급 버튼
        /// </summary>
        private bool WelcomeCard_Issue(string sCardNo = "")
        {
            string sRet = UserCom.RST_ERR;

            if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return false;
            if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return false;

            if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1")
            {

                WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0790);
                return false;

            }

            try
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "[WelcomeCard_Issue] WELCOMECARD_ISSUE Open!  ");

                //#20180413 웰컴카드 신규기능 추가 start, 20180621
                //기존
                //sRet = WinPay.ShowForm(new string[] { FormManager.FORM_WELCOMECARD_ISSUE, PosKey.MENU_KEY.WELCOMECARD_ISSUE, "2", sCardNo });
                //변경
                sRet = WinPay.ShowForm(new string[] { FormManager.FORM_WELCOMECARD_ISSUE, PosKey.MENU_KEY.WELCOMECARD_ISSUE, "2", sCardNo, "true" });
                
                //#20180413 웰컴카드 신규기능 추가 end, 20180621               

                if (sRet != UserCom.RST_OK)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                            ex.Message);

                return false;
            }
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 웰컴카드 전문조립

        /// <summary>
        /// 웰컴카드 전문조립
        /// </summary>
        private bool WelcomeCard_SetData(string sType)
        {
            string sRet = UserCom.RST_ERR;

            if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return false;
            if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return false;
            if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1")
            {

                WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0790);
                return false;

            }

            try
            {
                // 전문통신!!!
                string[] saRecvdData = null;
                sRet = m_cWelcomeCard.WelcomeCard_SendDataMake(PosConst.CANCEL_DIV.NORMAL,
                                                               new string[] {sType,                                    //웰컴타입                            
                                                                             m_sInPutData,                             //카드번호
                                                                             m_sInPutType,                             //입력구분
                                                                             m_sInHP_CustNumer,                        //HPC - 회원번호
                                                                             m_sInHP_WelcomeCard,                      //HPC - 웰컴카드번호
                                                                             m_sInWelcomeCard_Type,                    //웰컴카드 C:실물카드, A:해피App
                                                                             "",                                       //통신사구분
                                                                             m_nDestAmt.ToString(),                    //할인대상금액
                                                                             DateTime.Now.ToString("yyyyMMdd"),        //거래일자(YYYYMMDD) 
                                                                             DateTime.Now.ToString("HHmmss"),          //거래시간(HHMMSS)
                                                                             "",                                       //승인번호	
                                                                             m_sReadingHPData
                                                                             },
                                                               ref saRecvdData);

                //if (sRet == UserCom.RST_OK &&
                //    sType == PosConst.WELCOMECARD_TYPE.ISSUE_SEARCH &&
                //    (saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode] == "50000" ||
                //     saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode] == "00200" ||
                //     saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode] == "99993"))
                //{
                //    //WinManager.ErrorMessage("해피앱 고객등록 할 수 없습니다. 미발급 된 번호 입니다.");
                //    WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1152));
                //
                //    return false;
                //}
                //
                //if (sRet == UserCom.RST_OK)
                //{
                //    return true;
                //}
                //else
                //{
                //    return false;
                //}

                if (sRet == UserCom.RST_OK)
                {
                    if (saRecvdData != null && sType == PosConst.WELCOMECARD_TYPE.ISSUE_SEARCH)
                    {
                        if (saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode].Trim() == "50000" || //등록 가능한 카드 (즉 미발급된카드)
                            saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode].Trim() == "00200" || //마스터 미등록된 카드
                            saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode].Trim() == "99993")
                        {
                            //WinManager.ErrorMessage("해피앱 고객등록 할 수 없습니다. 미발급 된 번호 입니다.");
                            WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1152));
                            return false;
                        }
                    }

                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + 
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()", 
                                            ex.Message);
                return false;
            }
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 리딩한 카드번호가 해피포인트 고객인지 체크
        private bool HP_Availability_Check()
        {
            bool bRet = false;
            bool bHP_YN = false;

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return bRet;
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return bRet;

                m_sInHP_CustNumer = "";
                m_sInHP_WelcomeCard = "";
                m_sInWelcomeCard_Type = "";
                bHP_YN = m_cWelcomeCard.ClientRegisterCheck(PosConst.WELCOMECARD_MSG.HP_SEARCH,
                                                            new string[] { m_sInPutType, m_sInMaskData, m_sInEncData, "1", "", m_sInPutData },
                                                            ref m_sInHP_CustNumer,      // HP회원번호
                                                            ref m_sInHP_WelcomeCard);   // HP웰컴카드번호

                if (bHP_YN == true && (m_sInHP_CustNumer != "" && m_sInHP_WelcomeCard != ""))
                {
                    m_sInWelcomeCard_Type = "A";
                    bRet = true;
                }
                else
                {
                    if (bHP_YN == false)
                    {
                        //WinManager.ErrorMessage("해피포인트 회원이 아닙니다. 회원가입 후 진행 해주세요.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1154));
                    }

                    if (m_sInHP_CustNumer == "" || m_sInHP_WelcomeCard == "")
                    {
                        //WinManager.ErrorMessage("웰컴할인 받으실 수 없습니다.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1155));
                    }
                    bRet = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                            ex.Message);

                return false;
            }
            return bRet;
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 해피앱 고객등록 시도
        private string WelcomeCard_ClientRegister()
        {
            string sRet = UserCom.RST_ERR;

            string sMsg = string.Empty;
            bool bClientRegister = false; // 고객의 '해피앱 고객등록' 동의여부 (true: 고객동의 false: 고객미동의)
            bool bAvailability = true; // 현재 해피고객의 '해피앱 고객등록' 가능여부 (true: 가능 false: 불가능) 

            try
            {

                // 조건체크
                //if (CheckTxtInPut(txtCardNo) == false) return sRet;

                //발급조회
                if (WelcomeCard_SetData(PosConst.WELCOMECARD_TYPE.ISSUE_SEARCH) == false) return sRet;

                // 메세지 
                sMsg = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1143);
                //"해피포인트 있으세요? HPC고객등록해드릴까요?";
                //sMsg = "HPC고객등록해드릴까요?";

                // 해피앱 고객등록 동의여부 체크 
                if (WinManager.QuestionMessage(sMsg) == true)
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                         "[해피앱등록 동의여부] 동의");

                    bClientRegister = true;

                    #region 해피포인트 데이터 검색 및 해피앱 고객등록 대상자인지 체크

                    m_sReadingHPData = "";

                    if (m_cWelcomeCard.ClientRegisterCheck(PosConst.WELCOMECARD_MSG.HP_REGISTER_DATA, new string[] { }, ref m_sInHP_CustNumer, ref m_sInHP_WelcomeCard) == true)
                    {
                        if (m_sInHP_WelcomeCard != "") { bAvailability = false; }
                        if (m_sInHP_CustNumer == "") { bAvailability = false; }
                        if (bAvailability != false)
                        {
                            m_sReadingHPData = PosConst.WELCOMECARD_MSG.HP_REGISTER_DATA;
                        }
                    }
                    else
                    {


                        //#20180413 웰컴카드 신규기능 추가 start, 20180621, 20180622
                        //기존
                        //WinPay.ShowForm(new string[] { FormManager.FORM_PAY_POINT_HAPPY_POINT, PosKey.MENU_KEY.HAPPY_POINT_SCH, "0", "2" });
                        //변경
                        string sRetShow = WinPay.ShowForm(new string[] { FormManager.FORM_PAY_POINT_HAPPY_POINT, PosKey.MENU_KEY.HAPPY_POINT_SCH, "0", "2" });
                        if (sRetShow != UserCom.RST_OK) return sRet;
                        //#20180413 웰컴카드 신규기능 추가 end, 20180621, 20180622

                        if (m_cWelcomeCard.ClientRegisterCheck(PosConst.WELCOMECARD_MSG.HP_SEARCH_DATA, new string[] { }, ref m_sInHP_CustNumer, ref m_sInHP_WelcomeCard) == true)
                        {
                            if (m_sInHP_WelcomeCard != "") { bAvailability = false; }
                            if (m_sInHP_CustNumer == "") { bAvailability = false; }
                            if (bAvailability != false)
                            {
                                m_sReadingHPData = PosConst.WELCOMECARD_MSG.HP_SEARCH_DATA;
                            }
                        }
                        else
                        {
                            //#20180413 웰컴카드 신규기능 추가 start, 20180621, 20180622
                            WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1154));
                            //#20180413 웰컴카드 신규기능 추가 end, 20180621, 20180622
                            return sRet;
                        }
                    }

                    #endregion

                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                         "[해피앱 고객등록 가능여부] HP웰컴카드번호 :" + m_sInHP_WelcomeCard + ", HP회원번호 :" + m_sInHP_CustNumer + ", INPUT카드번호 :" + m_sInPutData);

                    #region 해피에 등록된 웰컴카드 번호가 있으면 해피앱 고객등록 할 수 없다. 만약 등록하려던 웰컴카드 번호가 이미 해피에 연동된 번호일 때 발급취소를 진행하지 않는다.

                    // 해피포인트 조회 시 응답 전문에 웰컴카드번호가 있으면 해피앱 고객등록 안된다.
                    if (m_sInHP_WelcomeCard != "" && m_sInHP_WelcomeCard != m_sInPutData)
                    {
                        //WinManager.ErrorMessage("이미 고객등록 된 해피포인트 입니다. 해피앱 고객등록 할 수 없습니다.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1147));
                        return sRet;
                    }
                    else if (m_sInHP_WelcomeCard != "" && m_sInHP_WelcomeCard == m_sInPutData)
                    {
                        //WinManager.ErrorMessage("같은 번호로 이미 고객등록 된 해피포인트 입니다. ");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1148));
                        return sRet;
                    }

                    // 고객등록 기본 조건은 해피앱이고 회원번호가 존재해야 하며 웰컴카드 번호가 없어야 한다.
                    if (bAvailability == false)
                    {
                        //WinManager.ErrorMessage("해피앱 고객등록 대상자가 아닙니다.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1149));
                        return sRet;
                    }

                    #endregion

                    #region 고객동의 받았고 해피앱 고객등록 가능자일 때

                    if (bClientRegister == true && bAvailability == true)
                    {
                        // HPC 고객등록 시도
                        if (WelcomeCard_SetData(PosConst.WELCOMECARD_TYPE.HPC_CLIENT_REGISTER) == true)
                        {
                            // POS SERVER 고객등록 시도
                            WelcomeCard_SetData(PosConst.WELCOMECARD_TYPE.POS_CLIENT_REGISTER);

                            //WinManager.ErrorMessage("HPC 고객등록 성공!");
                            //WinManager.ConfirmMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1150), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1133));
                            WinManager.ConfirmMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1150));
                            sRet = UserCom.RST_OK;
                        }
                        else
                        {
                            //WinManager.ErrorMessage("HPC 고객등록 실패!");
                            //WinManager.ConfirmMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1151), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1133));
                            WinManager.ConfirmMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1151));
                            sRet = UserCom.RST_ERR;
                        }
                    }

                    #endregion
                }
                else
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                         "[해피앱등록 동의여부] 미동의");

                    bClientRegister = false;
                    bAvailability = false;

                    sRet = UserCom.RST_ERR;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                            "WelcomeCardIssueClick Exception : " + ex.Message);
                return UserCom.RST_ERR;
            }
            return sRet;
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj
    }
}
